cryptol-2.2.6: Cryptol: The Language of Cryptography

Copyright | (c) 2013-2015 Galois, Inc.
License | BSD3
Maintainer | cryptol@galois.com
Stability | provisional
Portability | portable
Safe Haskell | Safe
Language | Haskell98

Cryptol.Prims.Syntax

Description

Synopsis

- data TFun
  - = TCAdd
  - | TCSub
  - | TCMul
  - | TCDiv
  - | TCMod
  - | TCLg2
  - | TCExp
  - | TCWidth
  - | TCMin
  - | TCMax
  - | TCLenFromThen
  - | TCLenFromThenTo
- data ECon
  - = ECTrue
  - | ECFalse
  - | ECDemote
  - | ECPlus
  - | ECMinus
  - | ECMul
  - | ECDiv
  - | ECMod
  - | ECExp
  - | ECLg2
  - | ECNeg
  - | ECLt
  - | ECGt
  - | ECLtEq
  - | ECGtEq
  - | ECEq
  - | ECNotEq
  - | ECFunEq
  - | ECFunNotEq
  - | ECMin
  - | ECMax
  - | ECAnd
  - | ECOr
  - | ECXor
  - | ECCompl
  - | ECZero
  - | ECShiftL
  - | ECShiftR
  - | ECRotL
  - | ECRotR
  - | ECCat
  - | ECSplitAt
  - | ECJoin
  - | ECSplit
  - | ECReverse
  - | ECTranspose
  - | ECAt
  - | ECAtRange
  - | ECAtBack
  - | ECAtRangeBack
  - | ECFromThen
  - | ECFromTo
  - | ECFromThenTo
  - | ECInfFrom
  - | ECInfFromThen
  - | ECError
  - | ECPMul
  - | ECPDiv
  - | ECPMod
  - | ECRandom
- eBinOpPrec :: Map ECon (Assoc, Int)
- tBinOpPrec :: Map TFun (Assoc, Int)
- ppPrefix :: ECon -> Doc

# Documentation

data TFun Source

Built-in types.

Constructors

TCAdd

     : Num -> Num -> Num

TCSub

     : Num -> Num -> Num

TCMul

     : Num -> Num -> Num

TCDiv

     : Num -> Num -> Num

TCMod

     : Num -> Num -> Num

TCLg2

     : Num -> Num

TCExp

     : Num -> Num -> Num

TCWidth

     : Num -> Num

TCMin

     : Num -> Num -> Num

TCMax

     : Num -> Num -> Num

TCLenFromThen | `: Num -> Num -> Num -> Num` Example: `[ 1, 5 .. ] :: [lengthFromThen 1 5 b][b]`
TCLenFromThenTo | `: Num -> Num -> Num -> Num` Example: `[ 1, 5 .. 9 ] :: [lengthFromThenTo 1 5 9][b]`

Instances

Bounded TFun Source |
Enum TFun Source |
Eq TFun Source |
Ord TFun Source |
Show TFun Source |
PP TFun Source |
HasKind TFun Source |

data ECon Source

Built-in constants.

Constructors

ECTrue |
ECFalse |
ECDemote | Converts a numeric type into its corresponding value.
ECPlus |
ECMinus |
ECMul |
ECDiv |
ECMod |
ECExp |
ECLg2 |
ECNeg |
ECLt |
ECGt |
ECLtEq |
ECGtEq |
ECEq |
ECNotEq |
ECFunEq |
ECFunNotEq |
ECMin |
ECMax |
ECAnd |
ECOr |
ECXor |
ECCompl |
ECZero |
ECShiftL |
ECShiftR |
ECRotL |
ECRotR |
ECCat |
ECSplitAt |
ECJoin |
ECSplit |
ECReverse |
ECTranspose |
ECAt |
ECAtRange |
ECAtBack |
ECAtRangeBack |
ECFromThen |
ECFromTo |
ECFromThenTo |
ECInfFrom |
ECInfFromThen |
ECError |
ECPMul |
ECPDiv |
ECPMod |
ECRandom |

Instances

Bounded ECon Source |
Enum ECon Source |
Eq ECon Source |
Ord ECon Source |
Show ECon Source |
PP ECon Source |

eBinOpPrec :: Map ECon (Assoc, Int) Source

tBinOpPrec :: Map TFun (Assoc, Int) Source

ppPrefix :: ECon -> Doc Source